DIR   := src/logic
PACK  := Logic
DEP   := Util Rewriting
FILES := a.ml ass.ml assignment.ml binInt.ml binMinf.ml binNat.ml binNumber.ml binRat.ml binReal.ml binType.ml formula.ml integer.ml minf.ml miniSat.ml miniSatP.ml miniSmt.ml monad.ml number.ml operators.ml p.ml pss.ml rational.ml real.ml solver.ml state.ml yices.ml

include mk/subdir.mk

# Logic needs extra flags when linking
LOGICLIBS := minisat minisatp yices
LOGICOBJS := interface minisatPlus yinterface
LINK_Logic := -ccopt -L$(DIR_Logic)/build/yices/32bit/lib -ccopt -L$(DIR_Logic)/build/yices/64bit/lib -I $(BUILD)/minisat -I $(BUILD)/minisat+ -I $(BUILD)/yices $(LOGICLIBS:=.cmxa) $(LOGICOBJS:=.cmx)

# minisat
$(BUILD)/miniSat.cmx $(BUILD)/miniSat.cmo: $(BUILD)/interface.cmi

$(BUILD)/interface.cmi:
	cp -r $(SRC_Logic)/minisat $(BUILD_Logic)
	$(MAKE) -C $(BUILD_Logic)/minisat
	cp $(BUILD_Logic)/minisat/interface.cmi $@

# minisat+
$(BUILD)/miniSatP.cmx $(BUILD)/miniSatP.cmo: $(BUILD)/minisatPlus.cmi

$(BUILD)/minisatPlus.cmi:
	cp -r $(SRC_Logic)/minisat+ $(BUILD_Logic)
	$(MAKE) -C $(BUILD_Logic)/minisat+
	cp $(BUILD_Logic)/minisat+/minisatPlus.cmi $@

# yices
$(BUILD)/yices.cmx $(BUILD)/yices.cmo: $(BUILD)/yinterface.cmi

$(BUILD)/yinterface.cmi:
	cp -r $(SRC_Logic)/yices $(BUILD_Logic)
	$(MAKE) -C $(BUILD_Logic)/yices
	cp $(BUILD_Logic)/yices/yinterface.cmi $@
